<?php 
/*	+---------------+-------------------+---------------+-----------------------+
	|	Program		|	Pox-Proxy		|	File		|	body.php			|
	|	Author		|	Michael Harris	|	Function	|	The main file for	|
	|	Version		|	V .6a			|				|	the Pox system.		|
	|	Modified	|	02/12/07 		|	Copyright	|	2007				|
	+---------------+-------------------+---------------+-----------------------+
	|	This program is free software: you can redistribute it and/or modify	|
	|	it under the terms of the GNU Affero General Public License as			|
	|	published by the Free Software Foundation, either version 3 of the		|
	|	License, or (at your option) any later version.							|
	|																			|
	|    This program is distributed in the hope that it will be useful,		|
	|    but WITHOUT ANY WARRANTY; without even the implied warranty of			|
	|    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the			|
	|    GNU Affero General Public License for more details.					|
	|																			|
	|   You should have received a copy of the GNU Affero General Public 		|
    |	License along with this program.  If not, see 							|
	|	<http://www.gnu.org/licenses/>.											|
	|																			|
	+---------------+-------------------+---------------------------------------+
*/
/*	+-------------------------------------------------------------------------------+ 
	|	These scripts contain functions, and code from other programs as outlined 	|
	|	below. 																		|
	|	None being used just now.													|
	+-------------------------------------------------------------------------------+
*/
/*	+-------------------------------------------------------------------------------+ 
	|	When creating these scripts, I received inspiration, ideas and concepts		|
	|	from the following other programs (not written by me).						|
	|	PHProxy (Poxy) by Abdullah Arif 2002-2007, URL proxy v1.3 Pre-Alpha by Bob 	|
	|	Matcuk and Scott Atkins 2002, and Ottoscript by Scott Atkins 2002.			|			
	|	Though, in reality, many of the ideas in these scripts I thought of 		|
	|	independently first, and only looked for inspiration when having trouble 	|
	|	putting my ideas into practice. That's how things often are...				|
	+-------------------------------------------------------------------------------+
*/
/*	+-------------------------------------------------------------------------------+
	|	The files which are part of the Pox system are: frameset.php, controls.php,	|
	|	settings.php, body.php, page.class.php, and functions.php. 					|
	|	Though, only the last four are strictly needed.								|
	+-------------------------------------------------------------------------------+
*/

/*
This program will fetch a page or file from a remote location, and then display it. 
It will eventually be able to fetch images and similar that are linked to or embeded in (e.g) HTML files.
As well as, pass cookies between the end user and the site, GET and POST (form) data and so on. 

Where the 'todo' or 'tofix' are, indicates a place where work needs to be done. 

The following text has some ideas that were just jotted down over time. 


It is intended that this program will take a $_GET that is a URI, and then return that page. 
It is intended to be able to pass on cookies, JavaScript, 403 access popups (whatever they are called) (if that is possible), images, flash things, CSS and all the rest of the browsing experience. As well, it should be able to pass back any form information, cookies etc. to the original webpage. 

Passing on images etc. from the original site requires write access to the server, these are disabled by defualt, and currently not actually working...

It will consist of two parts, which will be in two different frames. The main frame will display the text etc., the second will contain controls (allow/disallow cookies, Javascript etc., show only main frame, goto original etc.).

It might potentially be protected by .htaccess and/or by a PHP login script (such as the one from textedit). 

It will probably cache the various pages it accesses, as well as images etc. It will then use the header "If-Modified-Since: date" (and the modified date on the files in the Cache will be date) to determine if it has to then fetch things again.

It will, in the future, be able to understand the "Pragma" heading, and thus not use the cache.

It will pass on GET and POST (thus be able to use forms, and combined with cookies, access 'hidden' areas).
See test.php for passing on POST info, or else the refernce list below.

It will have good security, each user will have a separate cache, cookies etc. Thus one user can't access another's cookies etc.

It will offer the ability to see the source, rather then display the page. (Using head.php).

It has to be remembered that lots of HTML tags contain external links, take this list from the Poxy Proxy system. 

    $tags = array
    (
        'a'          => array('href'),
        'img'        => array('src', 'longdesc'),
        'image'      => array('src', 'longdesc'),
        'body'       => array('background'),
        'base'       => array('href'),
        'frame'      => array('src', 'longdesc'),
        'iframe'     => array('src', 'longdesc'),
        'head'       => array('profile'),
        'layer'      => array('src'),
        'input'      => array('src', 'usemap'),
        'form'       => array('action'),
        'area'       => array('href'),
        'link'       => array('href', 'src', 'urn'),
        'meta'       => array('content'),
        'param'      => array('value'),
        'applet'     => array('codebase', 'code', 'object', 'archive'),
        'object'     => array('usermap', 'codebase', 'classid', 'archive', 'data'),
        'script'     => array('src'),
        'select'     => array('src'),
        'hr'         => array('src'),
        'table'      => array('background'),
        'tr'         => array('background'),
        'th'         => array('background'),
        'td'         => array('background'),
        'bgsound'    => array('src'),
        'blockquote' => array('cite'),
        'del'        => array('cite'),
        'embed'      => array('src'),
        'fig'        => array('src', 'imagemap'),
        'ilayer'     => array('src'),
        'ins'        => array('cite'),
        'note'       => array('src'),
        'overlay'    => array('src', 'imagemap'),
        'q'          => array('cite'),
        'ul'         => array('src')
    );

Todo
1) Take a get request and grab the corresponding page and display it.  -done
2) Replace all anchors so that they go via the proxy... - done partially, see function anchor_replace() in page.class.php
3) Make sure can respond to challenge/authentication requests (403)
4) Have a list of 'allowed' mimetypes. Anything not on the list, gets an error. - done
5) Working body/controls frames setup. - not done.
6.1) Fix, remove whatever, all the above tags so that they don't have any bloody external links at all...
6.2) Any references to external material, get it copied to the server, to be dished up if needed...
7) Insert an <meta name="robots" content="noindex,nofollow" /> or <meta name="robots" content="noindex,nofollow"> into the head of any document. Perhaps. 

References, information and functions that might be useful.
file:///home/michael/Desktop/phpmanual/wrappers.http.html
file:///home/michael/Desktop/phpmanual/ref.stream.html
*/
/* This now uses the page.class.php file, which includes a class with all the useful page manipulation functions. As such, it should be included.*/
require ('page.class.php');
//All the settings are another file as well.
require_once ('settings.php');
//and now the functions...
require ('functions.php');
if ($debug)
{
	error_reporting(E_ALL);
//	error_reporting(E_STRICT);
}
else 
{
	error_reporting(0);
}
	ini_set('user_agent', $useragent);//set the user agent that is sent when requesting pages. 
	$url=$_GET[$getvar]; //$getvar is set in settings.php . See the relevant comment in that file for more information.
session_start();// start the session. 
//copy all the variables into the session variables, if it is a new session
//this is so that users can change these variables on the fly. 
//If you don't want users to be able to change any of these variables, then disable that in controls.php
//see instructions in controls.php for how to do this. This section of code should not be needed to be touched.
//Also, it is my opinion that the user should not be able to change any other setting, hence why they aren't here.
if (!isset($_SESSION['aaa']))
{
	$_SESSION['alt']['images']=$alt['images'];
	$_SESSION['alt']['objects']=$alt['objects'];
	$_SESSION['alt']['applets']=$alt['applets'];
	$_SESSION['alt']['frames']=$alt['frames'];
	$_SESSION['delete']['applets']=$delete['applets'];
	$_SESSION['delete']['images']=$delete['images'];
	$_SESSION['delete']['cookies']=$delete['cookies'];
	$_SESSION['delete']['script']=$delete['script'];
	$_SESSION['delete']['objects']=$delete['objects'];
	$_SESSION['delete']['frames']=$delete['frames'];
	$_SESSION['delete']['styles']=$delete['styles'];
	$_SESSION['copy']['applets']=$copy['applets'];
	$_SESSION['copy']['images']=$copy['images'];
	$_SESSION['copy']['cookies']=$copy['cookies'];
	$_SESSION['copy']['script']=$copy['script'];
	$_SESSION['copy']['objects']=$copy['objects'];
	$_SESSION['copy']['frames']=$copy['frames'];
	$_SESSION['copy']['styles']=$copy['styles'];
}
$_SESSION['aaa']=true;//this is a new session now.
//main code. 
	{
		if ($file=fopen($url,"rb"))//todo, tofix need to catch errors from non-existent files...
		{
			$metahead=stream_get_meta_data($file);
//cookies? yum..., I'm sure we could use this to check and pass onto the user the site cookies.
//of course, we would need a place to get the cookies back from the user but $_COOKIES[] exists...
//in the future, baby.
			$mimetype=mimetype($metahead);

			if ($RestrictMimetypes)//if we are going to restrict mimetypes, then
			{
				$ttt=false;//$ttt is a control variable. ttt stands for "The mimeType Tested?" (Haha.)
				foreach ($mimetype_dl as $mmm)//check each mimetype
				{
					if (($mimetype == $mmm))//if the mime type is allowed, then skip, else
					{
						$ttt=true;//the mimetype is matched...
						break;
					}
				}//else if it matches none of them, then...
				if (!$ttt)
				{
					echo ("The file you are trying to open is of a mimetype that is not allowed.");
					fclose($file); //close the file, 
					exit();//and exit
				}

			}
			$generictype=genericfiletype($metahead);
			if ($generictype=='text')
			{
//start of text part. ********************************
//variable variables? $$a file:///home/michael/Desktop/phpmanual/language.variables.variable.html
//				if ($filecontents=fread($file,filesize($url)))//filesize isn't working! Same problem as file_exists?
//todo fixme, it would be better(?) if it used the file pointer already opened, i.e. used the above line, rather then below.
				if ($filecontents=file_get_contents($url))
				{
					$result= new page ($filecontents,$user,$self,$url);
					$result->replace_anchor();	//replace all the anchors
	//				foreach ($delete as $func)	//delete everything that should be deleted
		//			if ($func)//todo tofix, rather then individual sections like the images and scripts one below, want a single section, but how to I get the variable name as a string? I guess I can't...
			//		{
				//		echo $func;//echos 11111
					//	$result->delete($func);
					//}

					if ($_SESSION['delete']['images'])
					{
						if ($_SESSION['alt']['images'])
						{
							$result->alt_image();
						}
						$result->delete_image();
					}
					elseif ($_SESSION['copy']['images'])
					{
						$result->copy_image();
					}
					if ($_SESSION['delete']['objects'])
					{
						if ($_SESSION['alt']['objects'])
						{
							$result->alt_object();
						}
						$result->delete_object();
					}
					if ($_SESSION['delete']['styles'])
					{
						$result->delete_style();
					}
					elseif ($_SESSION['copy']['styles'])
					{
						$result->copy_style();
					}
					if ($_SESSION['delete']['script'])
					{
						$result->delete_style();
					}
					elseif ($_SESSION['copy']['script'])
					{
						$result->copy_style();
					}
					echo ($result->givepage());//if it isn't above, simply display. 

				}
//end of text part ********************************
			}
			else //if it ain't text, pass it on (if allowed)
			{
//start of non text ********************************
				if ($PassOnNonText)
				{
					header("Content-Type: ".$mimetype);
					//This next line forces the browser to automatically download the file.
					if ($forcedownload){header("Content-Disposition: attachment; filename=".basename($url));}
					fpassthru($file);
				}
				echo ('Non-text file support is turned off.');
//end of non text ********************************
			}
		fclose($file);//only close the file if it is open.
		}
		else 
		{
			echo ('problem fetching page: <em>'.$url.'</em>.  The page may not exist.');
		}
	}
?>
