<?php 
/*	+---------------+-------------------+---------------+-----------------------+
	|	Program		|	Pox-Proxy		|	File		|	page.class.php		|
	|	Author		|	Michael Harris	|	Function	|	Contains the 		|
	|	Version		|	V .6a			|				|	page class file,	|
	|	Modified	|	27/11/2007		|				|	which modifies the	|
	|	Copyright	|	2007			|				|	proxied page.		|
	+---------------+-------------------+---------------+-----------------------+
	|	This program is free software: you can redistribute it and/or modify	|
	|	it under the terms of the GNU Affero General Public License as			|
	|	published by the Free Software Foundation, either version 3 of the		|
	|	License, or (at your option) any later version.							|
	|																			|
	+---------------------------------------------------------------------------+
*/
/* Page class, this class is part of the Pox Proxy system, and has functions to do various things to a page that is requested by a user. It will change anchors, delete or copy to the proxy images, applets, objects, frames, script etc.*/
/* todo
1) Fix relative URL replacing, in anchor_replace and image copy etc.
2) Fix copying styles
3) Remove all the 'onclick' and other events... $x=preg_replace('!<(.*)onclick="(.*)"(.*)>!iU','<$1 $3>',$text); //any tag <> that contains onclick= is replaced by that same tag, without the onclick="". Case insensitive (i) and not greedy (U).
4) Fix quote stuff in everything... Currently only checking for double quotes ("), have to also check for single quotes (') and empty (). Because each of these is used, and needs to be accounted for.

*/

class page
{

	var $content='';//the page.
	var $user;//the user who 'owns' the session. (Currently not used.)
	var $poxloc;//location of the proxy, $self in settings.php
	var $page_url;//the requested page.
	var $path;//these three are determined from the previous setting.
	var $filename;//the basename for the url
	var $dirn;//the directory name
	var $host;//scheme and domain name.
	/* constructor */
	function __construct($content,$user, $tim, $sig)
	{
		$this->content=$content;
		$this->user=$user;
		$this->poxloc=$tim;
		$this->page_url=$sig;

		$this->filename=basename($this->page_url);
//		echo ("<br />file: $this->filename<br />");
		$this->dirn=dirname($this->page_url);
	//	echo ("<br />dirn: $this->dirn<br />");
		$this->path=parse_url($this->page_url, PHP_URL_PATH);
		//echo ("<br />path: $this->path<br />");
		$this->host=parse_url($this->page_url, PHP_URL_SCHEME).'://'.parse_url($this->page_url, PHP_URL_HOST);
	//	echo ("<br />host: $this->host<br />");

	}


function givepage()
{
	return $this->content;
}

//ottoscript was the inspiration for this function, though no code was used. 
//this function with go through $this->content, and for each $tag with an $attribute, replace all (') or () with 
//double quotes (")
//When used at the start of the other functions, it enables them to be simpler.
//XHTML requires quote marks of course, if it has () the browser will 'barf'.
function replace_quotes($tag,$attribute)
{
	global $quote;//this is set in settings.php
	foreach ($quote as $q)
	{//where there exists <$tag, followed by anything, then $attribute= then anything in between two $q (quotemarks), then more stuff and the end >, replace it with the same, but double quotes instead of $q
		$this->content=preg_replace("~<$tag(.*)$attribute=$q(.*)$q(.*)>~iU","<$tag$1$attribute=\"$2\"$3>",$this->content);




	}
}


function replace_anchor()
{// need to make it so that if there is relative anchoring (i.e. the anchor doesn't have a protocol at the start), 
	// 		that it replaces the relative anchoring with absolute anchoring, /and then/ adds the proxy stuff.	
	// replace all the anchor tags with anchors that point to the proxy+old_anchor - done

/* Things todo in this function. 
1) Use any of double quotes (") or single quotes (') or nothing () in href= sections. see function replace_quotes
2) Fix relative anchoring # to point to the correct thing...
3) Same fix as 2, fix so that when viewing a directory, rather then a file, that it has the correct links...

*/
/* with regards to replacing anchor quotes, it sucks.*/
global $debug2;
if ($debug2)
	{
		echo ($this->host.$this->path.'<br>'.$this->dirn.'/'.$this->filename);
	}


//	$this->replace_quotes("a","href");//replace all quotes used by 'href' attributes in 'a' tags with double quotes


//from here, all the anchors are assumed to be made up of two double quotes...
	//this adds the http://path to all the anchors that don't have it.
//this one is good for # anchors
	$this->content=preg_replace('~<a(.*)href="(?!((.){2,4}://))(.*)"(.*)>~iU','<a$1href="'.$this->host.$this->path.'/$4"$5>',$this->content);
//this one is good for directories.
//	$this->content=preg_replace('~<a(.*)href="(?!((.){2,4}://))(.*)"(.*)>~iU','<a$1href="'.$this->dirn.'/$4"$5>',$this->content);

	//adds the proxy stuff //this should replace all anchor tags with one that goes through the proxy.
	$this->content=preg_replace('~<a(.*)href="(.*)"(.*)>~iU', '<a$1href="'.$this->poxloc.'$2"$3>', $this->content);

	//This next line would add a 'target="body"' etc. if the frames system was in use. Well, actualy?
//	$this->content=preg_replace('/<a(.*)>/iU', '<a$1 target="body">', $this->content);
}


function alt_image()
{//replaces any images with alt tags with what is in the alt tag.
	$this->content=preg_replace('/<img(.*?)alt="(.*?)"(.*?)>/','<p><em>img:</em> $2</p>',$this->content);
}

function alt_object()
{//anything in between the object tags is returned instead of the object.
	$this->content=preg_replace('/<object(.*?)>(.*?)<\/object(.*?)>/i', '<p><em>obj:</em> $2</p>', $this->content);
}
function alt_applet()
{//anything in between the applet tags is returned instead of the applet.
	$this->content=preg_replace('/<applet(.*?)>(.*?)<\/applet(.*?)>/i', '<p><em>app:</em> $2</p>', $this->content);
}
function alt_frames()
{ //todo
}

//delete functions
function delete($func)//this isn't used as the control function is not yet fixed up.
{
	if ($func=='images')
	{
		$this->image_delete();
	}
}
function delete_image()
{//Delete all images. 
	$this->content=preg_replace('/<img(.*?)>/i', '', $this->content);
}
function delete_script()
{//Delete all <script*>*</script> tags. 
//As well, it needs to delete links to scripts. 
	$this->content=preg_replace('/<script(.*?)>(.*?)<\/script(.*?)>/iU', '', $this->content);
}
function delete_cookies()
{//todo, this will not pass on cookies? what about headers, the headers aren't even being passed to the object...
//headers? We have to pass on content-type headers and some others...
}
function delete_object()
{//Delete all <object*>*</object> tags. 
	$this->content=preg_replace('/<object(.*?)>(.*?)<\/object(.*?)>/i', '', $this->content);
}
function delete_applet()
{//Delete all <applet*>*</applet> tags. 
//As well, it needs to delete links to applet. 
	$this->content=preg_replace('/<applet(.*?)>(.*?)<\/applet(.*?)>/i', '', $this->content);
}
function delete_frame()
{//todo
}
function delete_style()//todo
{//Delete all <style*>*</style> tags. And all links to style sheets! 
	$this->content=preg_replace('/<style(.*?)>(.*?)<\/style(.*?)>/i', '', $this->content);
//and inline style... (Again, quotes..., perhaps wehn we create the quote method of script, we can use it here too...)
	$this->content=preg_replace('/<(.*?)style="(.*?)"(.*?)>/i', '<$1 $3>', $this->content);
}


/*
//copy functions todo */

function copy_gen($matches)//generic copy function. Will parse an array from preg_match_all, 
{	//create directories and copy all files.
//gotcha, it doesn't return problems...
// the URLs have to be fully qualified.
	foreach ($matches as $file)
	{
		$file_url=$file[2];
	echo ('<br>'.$file_url);
//		if (file_exists($file_url))//only bother doing anything if the remote file exists...
		{//'cept that file_exists has mightta problems...

			//parse the fully qualified (not relative) URL, splitting it into chunks!.
			$file_parsed_url=parse_url($file_url);//have to remove the filename, so that it is just the directory. 
			//create a directory structure based on these chunks, scheme, host, path
			$dir='cache/'.$file_parsed_url['scheme'].'/'.$file_parsed_url['host'].''.$file_parsed_url['path'];
			$dir_a=pathinfo ($dir);
			$dir=$dir_a['dirname'];
			if (!file_exists($dir))
			{
				mkdir ($dir,0777,true);//true is 'recursive'
			}
			else {}
			//fetch the file and save in the directory structure!
			if (!file_exists($dir.'/'.$dir_a['basename']))
			{
				copy ($file_url,$dir.'/'.$dir_a['basename']);
			}
			else {}
		}
	}
}

function copy_image()
{//this one will, go through and and copy all the images to the server, and replace all the src to point to the local copy.

	$this->replace_quotes('img','src');//this replaces all quotes with double quotes.

//the replace quotes above does the work of the next few lines.
//replaces no quotes or a space at the start of a src info block, with double quotes (hopefully...)
// 'cept it doesn't work....
//	$this->content=preg_replace("~<img(.*)src=( ?)(.*) (.*)>~iU",'<img$1src="$3"$4>',$this->content);
//replaces single quotes around the src info with double quotes.
//	$this->content=preg_replace("~<img(.*)src='(.*)'(.*)>~iU",'<img$1src="$2"$3>',$this->content);

//this replace rearranges the image tags so that the src bit is the first bit, thus it is easy to find in the next part.
	$this->content=preg_replace ('/<img(.*?)src="(.*?)"(.*?)>/i', '<img src="$2"$1$3>',$this->content);

//first, get all the URLs for all the images, get them and save them to the local HD
	if (preg_match_all('/<img(.*?)src="(.*?)"(.*?)>/i',$this->content,$matches,PREG_SET_ORDER))
	{
		//echo ('<br>---'.count($matches).' ---  ');
		//if not a fully qualified URL, then make it so! (Can just steal shit from anchor replace once done.)
		//todo, not done. :) Pretend it is done though...	
		$this->copy_gen($matches);
/*		foreach ($matches as $img)
		{
			$img_url=$img[2];
			if (file_exists($img_url))//only bother doing anything if the remote image exists...
			{
				//parse the fully qualified (not relative) URL, splitting it into chunks!.
				$img_parsed_url=parse_url($img_url);//have to remove the filename, so that it is just the directory. 
				//create a directory structure based on these chunks, scheme, host, path
				$dir='cache/'.$img_parsed_url['scheme'].'/'.$img_parsed_url['host'].''.$img_parsed_url['path'];
				$dir_a=pathinfo ($dir);
				$dir=$dir_a['dirname'];
				if (!file_exists($dir))
				{
					mkdir ($dir,0777,true);//true is 'recursive'
				}
				else {}
				//fetch the file and save in the directory structure!
				if (!file_exists($dir.'/'.$dir_a['basename']) and file_exists($img_url))
				{
					copy ($img_url,$dir.'/'.$dir_a['basename']);
				}
				else {}
			}
		}*/

	//second, replace all image tags so that they point to a local copy, 
//for an image tag (<img) with stuff ((.*)) and a source (src="), the scheme ((.){2,4), 2-4 chars, the rest of the URL ((.*)), the end of the source ("), and the rest of the tag ((.*)>). Everything is case insensitive and not greedy (iU). 
//create an image tag (<img) with the first anything ($1) the source tag (src=") the new position (cache/etc.) which includes the scheme ($2) and the rest of the URL ((.*))
		$this->content=preg_replace('~<img(.*)src="(.?)(.?)(.?)(.?)://(.*)"(.*)>~iU', '<img$1src="cache/$2$3$4$5/$6"$7>', $this->content);

//		$this->content=preg_replace('/<img(.*)src="(.){2,4}(.*)"(.*)>/iU', '<img$1src="cache/$2/$3"$4>', $this->content);
	}
	else {/*There are no images... Stupid.*/}
}
/*
"cookies"	=>true,
	"images"	=>true,
	"script"	=>true,
	"objects"	=>true,
	"applets"	=>true,
	"frames"	=>true,
	"styles"
function cookies_copy()
{//this one will either, go through and and copy all the cookies, and then pass them on as cookies. 
	return $this->content;
}
function script_copy()
{//this one will either, go through and and copy all the script files to the local machine, or else etc. (as above)
	return $this->content;
}
function objects_copy()
{//this one will either, go through and and copy all the object files to the local machine, or else etc. (as above)
	return $this->content;
}
function applets_copy()
{//this one will either, go through and and copy all the applets files to the local machine, or else etc. (as above)
	return $this->content;
}
function frames_copy()
{//this one will either, go through and and copy all the frames files to the local machine, or else etc. (as above)
//as well, it should really go through each frame doing the same stuff as happened to the main page. 
	return $this->content;
}*/
function copy_style()
{//this one will either, go through and and copy all the style files to the local machine, or else etc. (as above)
	return $this->content;
}


}

?>
