<?php //noshow
/*	+---------------+-------------------+---------------+-----------------------+
	|	Program		|	Pox-Proxy		|	File		|	settings.php		|
	|	Author		|	Michael Harris	|	Function	|	Contains the 		|
	|	Version		|	V .6a			|				|	various settings	|
	|	Modified	|	02/12/07 		|				|	for the Pox system.	|
	|	Copyright	|	2007			|				|						|
	+---------------+-------------------+---------------+-----------------------+
	|	This program is free software: you can redistribute it and/or modify	|
	|	it under the terms of the GNU Affero General Public License as			|
	|	published by the Free Software Foundation, either version 3 of the		|
	|	License, or (at your option) any later version.							|
	|																			|
	+---------------------------------------------------------------------------+
*/
//username and password, possibly useful. Used later when dealing with copying files such as images, and with cookies.
$user='fred';
$pass='fred';//Ideally this would be hashed with a salt. 

$version = '.6a';//the version number.
//if debug equals true, then current debug messages are shown. This includes error messages. 
global $debug;
$debug=true;
//if debug2 equals true, then old and possibly useless debug messages are shown
global $debug2;
$debug2=false;

$useragent='Pox-Proxy/'.$version.' (email: harrismw@ids.org.au)';//the useragent of the Pox system.

$getvar='URL';//The variable in the command line of the browser. You might want to change it to disguise the use of a proxy slightly. 
$self="body.php?".$getvar."=";//$_SERVER['PHP_SELF'].'?URL=';//where the current page is, to re-write all the anchors.

//an array with all the quote marks that could be used in the html tags, e.g. <a href=""> <a href=''> etc.
//this is accessed via a global decleration in a function in page.class.php
$quote=array("'");//you could have double quotes ("), but it would be extra proccessing for no reason. As well, no quotes doesn't work so well now...


//the default position is true for the alt, true for all of the delete and false for the copy. 
//the alt functions are only processed if the delete function for that type is set to true. 
// the alt displays any alternative text for the type of thing.
// the delete functions are processed first, and thus, if delete and copy images is set to true, it will delete them, leaving nothing to copy. 
//if both delete and copy are set to false, then one of two things will happen (depending on the image src). If it is a relative src (to the original server) it will display any alt or a broken symbol, if it has a protocol (http:// etc.), then it will be fetched by the browser. 
//It is suggested that objects, applets, frames and scripts be deleted as these could call home (perhaps).
//these are not used by or handed to the object that is created. 
$alt= array(
	"images"	=>true,/* what is in the alt='' part of the <img> tag*/
	"objects"	=>true,/* what is in between <object></object> tags*/
	"applets"	=>true,/* ditto*/
	"frames"	=>true /*this will return what is in <noframes> tags. */
);
$delete= array(
	"cookies"	=>true,
	"images"	=>true,
	"script"	=>true,
	"objects"	=>true,
	"applets"	=>true,
	"frames"	=>true,
	"styles"	=>true
);
$copy= array(
	"cookies"	=>false,
	"images"	=>false,
	"script"	=>false,
	"objects"	=>false,
	"applets"	=>false,
	"frames"	=>false,
	"styles"	=>false
);


//if this setting is set to false, all attempts to download non-text files (as defined in the function) (including application/ mimetypes, except application/xml+xhtml) are rejected. I would suggest that bandwidth considerations, and the possibility of porn or mp3s being downloaded by someone using the proxy, determine whether this is on or off. 
$PassOnNonText=true;
//this is only used if $passonnontext is true. It forces the non-text file to be downloaded, rather then displayed in the browser.
$forcedownload=false;

//this next setting will overwrite the $PassOnNonText setting above. In otherwords, if this is on, then it doesn't matter if a document is text or not. It will still be dropped. Though, if a non-text mimetype is here, but PassOnNonText is false, then it still gets dropped. 
$RestrictMimetypes=true;//
//mime types that you want to allow. If the mimetype isn't indicated here, then it will be automatically dropped. 
//oh, and this is only used if the setting above, $restrictmimetypes is true.
$mimetype_dl=array(//text
	"text/html","application/xhtml+xml","application/xml+xhtml","text/css","text/directory","text/plain",

//	"application/x-javascript",/* Is this text?*/ "text/javascript",
//images
	"image/bmp","image/gif","image/jpeg","image/tiff","image/png",
//movies, audio
/*	"audio/mpeg", "application/x-shockwave-flash",/*/
//other
	"application/pdf"

);

?>
